#        name: ISO 8601 date
# description: generate a `String` representation of `Timestamp` that is acceptable according to `ISO 8601`
#      author: Kai Burghardt <hackerman​@﻿Kai﻿Burghardt​.﻿de>
#   copyright: public domain, fall back to Creative Commons license zero

# This function
# * is not documented and as such may disappear at any moment
# * cannot be verified because ISO standard 8601 is not freely accessible
function standard::iso8601date(Timestamp $timestamp) >> String {
	#   %F  full ISO date
	#    T  literal `'T'`
	#   %X  short for %H:%M:%S
	#    .  literal `'.'`
	# %09N  zero-padded nine sub-second digits
	#  %:z  offset hours:minutes to UTC
	$timestamp.strftime('%FT%X.%09N%:z')
}
# EOF
