#        name: ordinary portable filename
# description: provides regular expressions matching a portable filename that is not special
#      author: Kai Burghardt <hackerman​@﻿Kai﻿Burghardt​.﻿de>
#   copyright: public domain, fall back to Creative Commons license zero

# The following Pattern does not match `'.'` and `'..'` indicating the current working directory and parent directory respectively.
type Standard::OrdinaryPortableFilename = Pattern[
		# one-character filename
		'\A[A-Za-z0-9_\-]\z',
		
		# two-character filename: either first or second character may be a dot
		'\A[A-Za-z0-9_\-][A-Za-z0-9._\-]\z',
		'\A[A-Za-z0-9._\-][A-Za-z0-9_\-]\z',
		
		# three-characters or more filename
		'\A[A-Za-z0-9._\-]{3,}\z'
	]
