#        name: partially-qualified domain name
# description: provides an PQDN observing the LDH (letters, digits, hyphen) rule
#      author: Kai Burghardt <hackerman​@﻿Kai﻿Burghardt​.﻿de>
#   copyright: public domain, fall back to Creative Commons license zero

type Standard::PartiallyQualifiedDomainName = Pattern[
		# ABC.DEF.GHI.JKL.         up to four labels
		'\A[A-Za-z][A-Za-z0-9]{,61}(\.[A-Za-z][A-Za-z0-9]{,62}){,3}\z',
		
		# A-B.C-D.E-F.G-H.         up to four labels containing dashes in the middle
		'\A[A-Za-z][A-Za-z0-9\-]{,60}[A-Za-z0-9](\.[A-Za-z][A-Za-z0-9\-]{,61}[A-Za-z0-9]){,3}\z',
		
		# A.B.C.D.E.               up to five labels – as of 2024 the longest internationalized ccTLD is 24 octets long
		'\A[A-Za-z][A-Za-z0-9\-]{,55}[A-Za-z0-9](\.[A-Za-z][A-Za-z0-9\-]{,54}[A-Za-z0-9]){,2}\.[A-Za-z][A-Za-z0-9\-]{,22}[A-Za-z0-9]\z'
	]
